SystemOrganization addCategory: #'HostMenus-Mac'!
SystemOrganization addCategory: #'HostMenus-Mac-Tests'!

TestCase subclass: #HostSystemMenusTest
	instanceVariableNames: 'menuBar interface secondaryMenu subMenu'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac-Tests'!

!HostSystemMenusTest classSide methodsFor: 'testing' stamp: 'MMP 7/28/2009 10:39'!
isAbstract
	^self isMacintosh not! !

!HostSystemMenusTest classSide methodsFor: 'utility' stamp: 'MMP 7/28/2009 10:38'!
isMacintosh
	^SmalltalkImage current platformName  = 'Mac OS'! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:23'!
applicationFirstMenu
	^1! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:25'!
arbitraryMenuItem
	^1! !

!HostSystemMenusTest methodsFor: 'as yet unclassified' stamp: 'John M McIntosh 11/19/2008 13:55'!
calculateShouldBeFrom2ndLevel: item using: c
	| shouldBe indexOf temp |
	
	shouldBe := item size < 3
			ifTrue: [item copyReplaceAll: c with: ' '.
					item copyReplaceAll: '(' with: ' '.]
			ifFalse: [(c = '(')
				ifTrue: [
					indexOf := item indexOf: $(.
					[((item at: indexOf) = $( and: [(item at: indexOf + 2) = $)])
						ifTrue: 
							[temp := item copy.
							((item at: indexOf + 1) = Character space or: [(item at: indexOf + 1) = $(])
								ifTrue: [temp at: indexOf put: Character space]
								ifFalse: [temp at: indexOf put: $/].
							temp at: indexOf + 2 put: Character space.
							temp]
						ifFalse: [temp := item copy.
								temp at: indexOf put: Character space].
								temp] 
							ifError: [temp := item copy.
									temp at: indexOf put: Character space.
									temp]]
				ifFalse: [item copyReplaceAll: c with: ' ']].
	(shouldBe indexOf: $() > 0 
		ifTrue: [shouldBe = '(' ifTrue: [self halt]. 
				^self calculateShouldBeFrom2ndLevel: shouldBe using: '('].
	^shouldBe! !

!HostSystemMenusTest methodsFor: 'as yet unclassified' stamp: 'John M McIntosh 11/19/2008 13:50'!
calculateShouldBeFrom: item using: c
	| |
	
	item replaceAll: $; with: Character space.
	item replaceAll: $^ with: Character space.
	item replaceAll: $!! with: Character space.
	item replaceAll: $< with: Character space.
	item replaceAll: $/ with: Character space.
	^self calculateShouldBeFrom2ndLevel: item using: c! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:24'!
editMenu
	^3! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:23'!
fileMenu
	^2! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'MMP 7/28/2009 10:39'!
isMacintosh
	^self class isMacintosh! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:45'!
mainWindowIndexNumber
	^1! !

!HostSystemMenusTest methodsFor: 'as yet unclassified' stamp: 'John M McIntosh 11/19/2008 14:15'!
modifySqueakMenu: aString 
	| results fixIndex middleCharacter |
	results := aString.
	results replaceAll: $; with: Character space.
	results replaceAll: $^ with: Character space.
	results replaceAll: $!! with: Character space.
	results replaceAll: $< with: Character space.
	results replaceAll: $/ with: Character space.
	fixIndex := results indexOf: $(.
	[fixIndex > 0]
		whileTrue: [
			[(results at: fixIndex + 2) = $)
				ifTrue: [middleCharacter := results at: fixIndex + 1.
						(middleCharacter = Character space or: [middleCharacter = $(])
							ifTrue: [results at: fixIndex put: Character space]
							ifFalse: [results at: fixIndex put: $/.].
						results at: fixIndex + 1 put: middleCharacter asUppercase.
						results at: fixIndex + 2 put: Character space]
				ifFalse: [results at: fixIndex put: Cinterfaceharacter space]] 
					ifError: [results at: fixIndex put:  Character space].
			fixIndex := results indexOf: $(].
	^ results! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:45'!
notUsedMenuNumber
	^5! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:50'!
notUsedMenuNumber2
	^4! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:21'!
quitItem
	^1! !

!HostSystemMenusTest methodsFor: 'initialize-release' stamp: 'JMM 10/21/2004 18:47'!
setUp
	interface := HostSystemMenus defaultMenuBarForWindowIndex: self mainWindowIndexNumber.
	menuBar := interface menuBar.
	secondaryMenu := nil.
	
! !

!HostSystemMenusTest methodsFor: 'initialize-release' stamp: 'JMM 8/26/2004 14:53'!
tearDown
	secondaryMenu ifNotNil: [interface deleteMenu: secondaryMenu].
	subMenu ifNotNil: [interface deleteMenu: subMenu]! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:55'!
testAppendWindowMenuMacOnly
	self isMacintosh ifFalse: [^self].
	interface appendStandardWindowMenu: 0.


	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'John M McIntosh 11/19/2008 14:57'!
testCharacterChanging
	| testString item shouldBe resultingString where |
	#(';' '^' '!!' '<' '/' '(' )
		do: [:c | #('*' '* ' '*  ' '**' '** ' '**  ' 
			')' '*)' '* )' '*  )' '**)' '** )' '**  )' 
			')' '*)' '*X)' '*XX)' '**)' '**X)' '**XX)' 
			'))' '*))' '*X))' '*XX))' '**))' '**X))' '**XX))' 
			'(' '*(' '*X(' '*XX(' '**)' '**X(' '**XX(' 
			'((' '*((' '*X((' '*XX((' '**((' '**X((' '**XX((' 
						 )
				do: [:template | 
					testString := template copyReplaceAll: '*' with: c.
					testString
						permutationsDo: [:mixedUp | 
							item := mixedUp copy.
							shouldBe := self calculateShouldBeFrom: item using: c.
							resultingString := self modifySqueakMenu: item copy.
							self should: [shouldBe = resultingString].
							(where := resultingString indexOf: $/) > 0
								ifTrue: [self should: [(mixedUp at: where) = $(].
										self should: [(mixedUp at: where+2) = $)].
										self should: [(mixedUp at: where+1) asUppercase = (resultingString at: where+1)]]]]]! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 1/15/2007 13:04'!
testCommandIDMacOnly
	"menuItemCommandID value is set by VM"
	| menuHandle menuItemCommandID |

	self isMacintosh ifFalse: [^self].
	(SmalltalkImage current osVersion asNumber < 1000) 
		ifTrue: [^self].
	menuHandle := interface getMenuHandle: self applicationFirstMenu.
	menuItemCommandID := interface getMenuItemCommandID: menuHandle item: self quitItem.
	(SmalltalkImage current osVersion asNumber >= 1000 and: [SmalltalkImage current osVersion asNumber < 1030]) 
		ifTrue: [self should: [menuItemCommandID = 0]. ^self].
	(SmalltalkImage current osVersion asNumber >= 1030) 
		ifTrue: [self should: [menuItemCommandID = 1886545254]. ^self].
	self should: [menuItemCommandID = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'John M McIntosh 11/1/2008 10:28'!
testCountsMacOnly
	"Mac test, check state of Menus installed by VM and by menu initialization counts are platform dependent"

	self isMacintosh ifFalse: [^self].
	(SmalltalkImage current  osVersion asNumber >= 1000) 
		ifTrue: 
			[self should: [(interface countMenuItems: (interface getMenuHandle: self applicationFirstMenu)) = 0]]
		ifFalse: 
			[self should: [(interface countMenuItems: (interface getMenuHandle: self applicationFirstMenu)) > 0].
			self should: [(interface countMenuItems: (interface getMenuHandle: self fileMenu)) = 6]].
	self should: [(interface countMenuItems: (interface getMenuHandle: self editMenu)) = 6].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:31'!
testEditMenuEncodingMacOnly
	| menuHandle menuItemTextEncoding |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemTextEncoding := interface getMenuItemTextEncoding: menuHandle item: self arbitraryMenuItem.
	self should: [menuItemTextEncoding = 4294967294 ].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:38'!
testEditMenuIsMenuItemEnabledMacOnly
	| menuHandle menuItemEnabled |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: self undoMenuItem.
	self should: [menuItemEnabled].
	interface enableMenuItem: menuHandle item: self undoMenuItem.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: self undoMenuItem.
	self should: [menuItemEnabled].
	interface disableMenuItem: menuHandle item: self undoMenuItem.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: self undoMenuItem.
	self should: [menuItemEnabled not].
	interface enableMenuItem: menuHandle item: self undoMenuItem.
! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:39'!
testEditMenuItemCmdMacOnly
	| menuHandle menuItemCmd |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemCmd := interface getItemCmd: menuHandle item: self undoMenuItem.
	self should: [menuItemCmd  = $Z].
	menuItemCmd := interface getItemCmd: menuHandle item: 3.
	self should: [menuItemCmd  = $X].
	menuItemCmd := interface getItemCmd: menuHandle item: 4.
	self should: [menuItemCmd  = $C].
	menuItemCmd := interface getItemCmd: menuHandle item: 5.
	self should: [menuItemCmd  = $V].
	menuItemCmd := interface getItemCmd: menuHandle item: 6.
	self should: [menuItemCmd  = 0 asCharacter].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:39'!
testEditMenuItemIconMacOnly
	| menuHandle menuItemIcon |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemIcon := interface getItemIcon: menuHandle item: self undoMenuItem.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 3.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 4.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 5.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 6.
	self should: [menuItemIcon  = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:40'!
testEditMenuItemMarkMacOnly
	| menuHandle menuItemMark |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemMark := interface getItemMark: menuHandle item: self undoMenuItem.
	self should: [menuItemMark = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 3.
	self should: [menuItemMark  = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 4.
	self should: [menuItemMark  = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 5.
	self should: [menuItemMark  = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 6.
	self should: [menuItemMark  = 0 asCharacter].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:41'!
testEditMenuItemStyle
	| menuHandle menuItemStyle |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemStyle := interface getItemStyle: menuHandle item: self undoMenuItem.
	self should: [menuItemStyle size = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 3.
	self should: [menuItemStyle size  = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 4.
	self should: [menuItemStyle size = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 5.
	self should: [menuItemStyle size = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 6.
	self should: [menuItemStyle size = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:42'!
testEditMenuItemsTextMacOnly
	| menuHandle menuItemText |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemText := interface getMenuItemText: menuHandle item: 1.
	self should: [menuItemText  = 'Undo'].
	menuItemText := interface getMenuItemText: menuHandle item: 2.
	self should: [menuItemText  = '-'].
	menuItemText := interface getMenuItemText: menuHandle item: 3.
	self should: [menuItemText  = 'Cut'].
	menuItemText := interface getMenuItemText: menuHandle item: 4.
	self should: [menuItemText  = 'Copy'].
	menuItemText := interface getMenuItemText: menuHandle item: 5.
	self should: [menuItemText  = 'Paste'].
	menuItemText := interface getMenuItemText: menuHandle item: 6.
	self should: [menuItemText  = 'Clear'].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:42'!
testEditMenuKeyGlyphMacOnly
	| menuHandle menuItemKeyGlyph |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self fileMenu.
	menuItemKeyGlyph := interface getMenuItemKeyGlyph: menuHandle item: self undoMenuItem.
	self should: [menuItemKeyGlyph = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:43'!
testEditMenuModifiersMacOnly
	| menuHandle menuItemModifiers |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self editMenu.
	menuItemModifiers := interface getMenuItemModifiers: menuHandle item: self undoMenuItem.
	self should: [menuItemModifiers size = 1].
	self should: [menuItemModifiers includes: #command].


! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 11/19/2004 13:21'!
testEncodingMacOnly
	"menuItemTextEncoding value is set by VM"
	| menuHandle menuItemTextEncoding |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self applicationFirstMenu.
	menuItemTextEncoding := interface getMenuItemTextEncoding: menuHandle item: self arbitraryMenuItem.
	self should: [menuItemTextEncoding isZero not ]. 

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 1/15/2007 13:04'!
testFileMenuCommandIDMacOnly
	| menuHandle menuItemCommandID |

	self isMacintosh ifFalse: [^self].
	(SmalltalkImage current osVersion asNumber < 1000) 
		ifTrue: [^self].
	menuHandle := interface getMenuHandle: self fileMenu.
	menuItemCommandID := interface getMenuItemCommandID: menuHandle item: self quitItem.
	self should: [menuItemCommandID = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:28'!
testFileMenuQuitEnabledMacOnly
	| menuHandle menuItemEnabled |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self fileMenu.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: self quitItem.
	self should: [menuItemEnabled].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:30'!
testFileMenuQuitTextMacOnly
	| menuHandle menuItemText |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self fileMenu.
	menuItemText := interface getMenuItemText: menuHandle item: self quitItem.
	self should: [menuItemText  = 'Quit do not save'].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:26'!
testFontIDMacOnly
	"menuItemFontID value is set by VM"
	| menuHandle menuItemFontID |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self applicationFirstMenu.
	menuItemFontID := interface getMenuItemFontID: menuHandle item: self arbitraryMenuItem.
	self should: [menuItemFontID = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:44'!
testGetMenuTitleMacOnly

	self isMacintosh ifFalse: [^self].
	self should: [(interface getMenuTitle: (interface getMenuHandle: 1)) = ''].
	self should: [(interface getMenuTitle: (interface getMenuHandle: 2)) = 'File'].
	self should: [(interface getMenuTitle: (interface getMenuHandle: 3)) = 'Edit'].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/21/2004 18:26'!
testKeyGlyphMacOnly
	"menuItemKeyGlyph value is set by VM"
	| menuHandle menuItemKeyGlyph |

	self isMacintosh ifFalse: [^self].
	menuHandle := interface getMenuHandle: self applicationFirstMenu.
	menuItemKeyGlyph := interface getMenuItemKeyGlyph: menuHandle item: self arbitraryMenuItem.
	self should: [menuItemKeyGlyph = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 11:27'!
testMenuHandles
	| menuHandle |
	1 to: 99 do: [:i | menuHandle :=  interface getMenuHandle: i.
			menuHandle isZero ifTrue: [^self]] 
! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'John M McIntosh 11/1/2008 10:28'!
testMenuHandlesCount
	(SmalltalkImage current   osVersion asNumber >= 1000) ifTrue: 
		[self should: [(interface countMenuItems: (interface getMenuHandle: 1)) = 0]]
		ifFalse: 
			[self should: [(interface countMenuItems: (interface getMenuHandle: 1)) > 0]].
	self should: [(interface countMenuItems: (interface getMenuHandle: 3)) = 6].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 1/15/2007 12:14'!
testMenuHandlesGetMenu1CommandID
	| menuHandle menuItemCommandID |
	menuHandle := interface getMenuHandle: 1.
	menuItemCommandID := interface getMenuItemCommandID: menuHandle item: 1.
	(SmalltalkImage current  osVersion asNumber >= 1000) 
		ifTrue: [self should: [menuItemCommandID = 1886545254]]
		ifFalse: [self should: [menuItemCommandID = 0]]

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 13:04'!
testMenuHandlesGetMenu1Encoding
	| menuHandle menuItemTextEncoding |
	menuHandle := interface getMenuHandle: 1.
	menuItemTextEncoding := interface getMenuItemTextEncoding: menuHandle item: 1.
	self should: [menuItemTextEncoding = 4294967294 ].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:36'!
testMenuHandlesGetMenu1FontID
	| menuHandle menuItemFontID |
	menuHandle := interface getMenuHandle: 1.
	menuItemFontID := interface getMenuItemFontID: menuHandle item: 1.
	self should: [menuItemFontID = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:40'!
testMenuHandlesGetMenu1KeyGlyph
	| menuHandle menuItemKeyGlyph |
	menuHandle := interface getMenuHandle: 1.
	menuItemKeyGlyph := interface getMenuItemKeyGlyph: menuHandle item: 1.
	self should: [menuItemKeyGlyph = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:28'!
testMenuHandlesGetMenu2CommandID
	| menuHandle menuItemCommandID |
	menuHandle := interface getMenuHandle: 2.
	menuItemCommandID := interface getMenuItemCommandID: menuHandle item: 1.
	self should: [menuItemCommandID = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 14:26'!
testMenuHandlesGetMenu2IsMenuItemEnabled
	| menuHandle menuItemEnabled |
	menuHandle := interface getMenuHandle: 2.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: 1.
	self should: [menuItemEnabled].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:22'!
testMenuHandlesGetMenu2Items
	| menuHandle menuItemText |
	menuHandle := interface getMenuHandle: 2.
	menuItemText := interface getMenuItemText: menuHandle item: 1.
	self should: [menuItemText  = 'Quit do not save'].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 13:04'!
testMenuHandlesGetMenu3Encoding
	| menuHandle menuItemTextEncoding |
	menuHandle := interface getMenuHandle: 3.
	menuItemTextEncoding := interface getMenuItemTextEncoding: menuHandle item: 1.
	self should: [menuItemTextEncoding = 4294967294 ].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/1/2004 16:07'!
testMenuHandlesGetMenu3IsMenuItemEnabled
	| menuHandle menuItemEnabled |
	menuHandle := interface getMenuHandle: 3.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: 1.
	self should: [menuItemEnabled].
	interface enableMenuItem: menuHandle item: 1.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: 1.
	self should: [menuItemEnabled].
	interface disableMenuItem: menuHandle item: 1.
	menuItemEnabled := interface isMenuItemEnabled: menuHandle item: 1.
	self should: [menuItemEnabled not].
	interface enableMenuItem: menuHandle item: 1.
! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 12:42'!
testMenuHandlesGetMenu3ItemCmd
	| menuHandle menuItemCmd |
	menuHandle := interface getMenuHandle: 3.
	menuItemCmd := interface getItemCmd: menuHandle item: 1.
	self should: [menuItemCmd  = $Z].
	menuItemCmd := interface getItemCmd: menuHandle item: 3.
	self should: [menuItemCmd  = $X].
	menuItemCmd := interface getItemCmd: menuHandle item: 4.
	self should: [menuItemCmd  = $C].
	menuItemCmd := interface getItemCmd: menuHandle item: 5.
	self should: [menuItemCmd  = $V].
	menuItemCmd := interface getItemCmd: menuHandle item: 6.
	self should: [menuItemCmd  = 0 asCharacter].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 14:01'!
testMenuHandlesGetMenu3ItemIcon
	| menuHandle menuItemIcon |
	menuHandle := interface getMenuHandle: 3.
	menuItemIcon := interface getItemIcon: menuHandle item: 1.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 3.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 4.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 5.
	self should: [menuItemIcon  = 0].
	menuItemIcon := interface getItemIcon: menuHandle item: 6.
	self should: [menuItemIcon  = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 15:02'!
testMenuHandlesGetMenu3ItemMark
	| menuHandle menuItemMark |
	menuHandle := interface getMenuHandle: 3.
	menuItemMark := interface getItemMark: menuHandle item: 1.
	self should: [menuItemMark = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 3.
	self should: [menuItemMark  = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 4.
	self should: [menuItemMark  = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 5.
	self should: [menuItemMark  = 0 asCharacter].
	menuItemMark := interface getItemMark: menuHandle item: 6.
	self should: [menuItemMark  = 0 asCharacter].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 14:17'!
testMenuHandlesGetMenu3ItemStyle
	| menuHandle menuItemStyle |
	menuHandle := interface getMenuHandle: 3.
	menuItemStyle := interface getItemStyle: menuHandle item: 1.
	self should: [menuItemStyle size = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 3.
	self should: [menuItemStyle size  = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 4.
	self should: [menuItemStyle size = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 5.
	self should: [menuItemStyle size = 0].
	menuItemStyle := interface getItemStyle: menuHandle item: 6.
	self should: [menuItemStyle size = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:25'!
testMenuHandlesGetMenu3Items
	| menuHandle menuItemText |
	menuHandle := interface getMenuHandle: 3.
	menuItemText := interface getMenuItemText: menuHandle item: 1.
	self should: [menuItemText  = 'Undo'].
	menuItemText := interface getMenuItemText: menuHandle item: 2.
	self should: [menuItemText  = '-'].
	menuItemText := interface getMenuItemText: menuHandle item: 3.
	self should: [menuItemText  = 'Cut'].
	menuItemText := interface getMenuItemText: menuHandle item: 4.
	self should: [menuItemText  = 'Copy'].
	menuItemText := interface getMenuItemText: menuHandle item: 5.
	self should: [menuItemText  = 'Paste'].
	menuItemText := interface getMenuItemText: menuHandle item: 6.
	self should: [menuItemText  = 'Clear'].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:40'!
testMenuHandlesGetMenu3KeyGlyph
	| menuHandle menuItemKeyGlyph |
	menuHandle := interface getMenuHandle: 3.
	menuItemKeyGlyph := interface getMenuItemKeyGlyph: menuHandle item: 1.
	self should: [menuItemKeyGlyph = 0].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 16:21'!
testMenuHandlesGetMenu3Modifiers
	| menuHandle menuItemModifiers |
	menuHandle := interface getMenuHandle: 3.
	menuItemModifiers := interface getMenuItemModifiers: menuHandle item: 1.
	self should: [menuItemModifiers size = 1].
	self should: [menuItemModifiers includes: #command].


! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/23/2004 12:13'!
testMenuHandlesGetMenuTitle
	self should: [(interface getMenuTitle: (interface getMenuHandle: 1)) = ''].
	self should: [(interface getMenuTitle: (interface getMenuHandle: 2)) = 'File'].
	self should: [(interface getMenuTitle: (interface getMenuHandle: 3)) = 'Edit'].

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/15/2004 12:38'!
testMenuHandlesNewMenu
	| menuString |
	menuString := 'Foobar'.
	secondaryMenu := interface newMenu: 5 menuTitle: menuString.
	interface insertMenu: secondaryMenu beforeID: 0.
	self should: [secondaryMenu = (interface getMenuHandle: 5)].
	interface drawMenuBar: 1.
	self should: [(interface getMenuTitle: secondaryMenu) = menuString].
	interface deleteMenu: secondaryMenu.
	self should: [(interface getMenuHandle: 5) = 0].
	secondaryMenu := nil

	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 1/15/2007 13:07'!
testMenuHandlesNewMenuAppend
	|  menuString items |
	menuString := 'Foobar'.
	secondaryMenu := interface newMenu: self notUsedMenuNumber2 menuTitle: menuString.
	interface insertMenu: secondaryMenu beforeID: 0.
	items := OrderedCollection with: (HostSystemMenusMenuItem menuString: 'one')
			with: (HostSystemMenusMenuItem menuString: 'two' keyboardKey: $a).
	interface appendMenu: secondaryMenu menuItems: items.
	self should: [(interface getMenuItemText: secondaryMenu item: 1) = 'one'].
	self should: [(interface getMenuItemText: secondaryMenu item: 2) = 'two'].
	self should: [(interface getItemCmd: secondaryMenu item: 2) = $A].
	self should: [(interface getItemIcon: secondaryMenu item: 1)  = 0].
	self should: [(interface getItemMark: secondaryMenu item: 1)  = 0 asCharacter].
	self should: [(interface getItemStyle: secondaryMenu item: 1) size = 0].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'stephane.ducasse 4/13/2009 20:30'!
testMenuHandlesNewMenuAppend2
	|  menuString items testArray |
	menuString := 'Foobar'.
	secondaryMenu := interface newMenu: self notUsedMenuNumber2 menuTitle: menuString.
	interface insertMenu: secondaryMenu beforeID: 0.
	items := OrderedCollection new.
	items add:  (HostSystemMenusMenuItem menuString: 'one').
	items add:  (HostSystemMenusMenuItem menuString: 'two').
	items add:  (HostSystemMenusMenuItem menuString: 'three').
	items add:  (HostSystemMenusMenuItem menuString: 'four').
	items add:  (HostSystemMenusMenuItem menuString: 'five').
	items add:  (HostSystemMenusMenuItem menuString: 'six').
	(items at: 1) styleAdd: #bold.
	(items at: 2) styleAdd: #italic.
	(items at: 3) styleAdd: #underline.
	(items at: 4) styleAdd: #outline.
	(items at: 5) styleAdd: #shadow.
	(items at: 6) styleAdd: #bold.
	(items at: 6) styleAdd: #italic.
	(items at: 6) styleAdd: #underline.
	(items at: 6) styleAdd: #outline.
	(items at: 6) styleAdd: #shadow.
	interface appendMenu: secondaryMenu menuItems: items.
	testArray := #(1 #bold 2 #italic 3 #underline 4 #outline 5 #shadow).
	testArray pairsDo: [:item :style |
		self should: [(interface getItemStyle: secondaryMenu item: item) size = 1].
		self should: [(interface getItemStyle: secondaryMenu item: item) includes: style]].
	testArray := #(6 #bold 6 #italic 6 #underline 6 #outline 6 #shadow).
	self should: [(interface getItemStyle: secondaryMenu item: 6) size = 5].
	testArray pairsDo: [:item :style |
		self should: [(interface getItemStyle: secondaryMenu item: item) includes: style]].
	

	



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 15:04'!
testMenuHandlesNewMenuAppendCheck

	self testMenuHandlesNewMenuAppend.
	self should: [(interface getItemMark: secondaryMenu item: 1)  = 0 asCharacter].
	interface checkMenuItem: secondaryMenu item: 1 checked: true.
	self should: [(interface getItemMark: secondaryMenu item: 1)  = 18 asCharacter].
	interface checkMenuItem: secondaryMenu item: 1 checked: false.
	self should: [(interface getItemMark: secondaryMenu item: 1)  = 0 asCharacter].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 14:57'!
testMenuHandlesNewMenuAppendCheckSetCmd

	self testMenuHandlesNewMenuAppend.
	interface setItemCmd: secondaryMenu item: 1 cmdChar: $x.
	self should: [(interface getItemCmd: secondaryMenu item: 1) = $x].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 1/15/2007 13:04'!
testMenuHandlesNewMenuAppendCheckSetCmd2

	(SmalltalkImage current osVersion asNumber < 1000) 
		ifTrue: [^self].
	self testMenuHandlesNewMenuAppend.
	interface setMenuItemCommandID: secondaryMenu item: 1 menuCommand: 120.
	self should: [(interface getMenuItemCommandID: secondaryMenu item: 1) = 120].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 1/15/2007 13:07'!
testMenuHandlesNewMenuAppendCheckSetItemHierarchicalID

	| menuString items |
	self testMenuHandlesNewMenuAppend.
	menuString := ''.
	subMenu := interface newMenu: self notUsedMenuNumber menuTitle: menuString.
	items := OrderedCollection with: (HostSystemMenusMenuItem menuString: 'three')
			with: (HostSystemMenusMenuItem menuString: 'four' keyboardKey: $b)..
	interface appendMenu: subMenu menuItems: items.
	self should: [(interface getMenuItemText: subMenu item: 1) = 'three'].
	self should: [(interface getMenuItemText: subMenu item: 2) = 'four'].
	self should: [(interface getItemCmd: subMenu item: 2) = $B].
	interface insertMenu: subMenu beforeID: -1.
	interface setMenuItemHierarchicalID: secondaryMenu item: 1 hierID: self notUsedMenuNumber.
	self should: [(interface getMenuItemHierarchicalID: secondaryMenu item: 1) = 5]

	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/26/2004 10:52'!
testMenuHandlesNewMenuAppendCheckSetItemModifiers
	| modifiers |
	
	self testMenuHandlesNewMenuAppend.
	modifiers := #( (#command)  (#shift) (#option) (#control) (#nocommand) 
		( #shift #option #control #nocommand)).
	modifiers do: [:m |
			interface setMenuItemModifiers: secondaryMenu item: 2 inModifiers: m.
			self should: [(interface getMenuItemModifiers: secondaryMenu item: 2) = m asSet]]
			


	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/26/2004 11:17'!
testMenuHandlesNewMenuAppendCheckSetItemText
	| string |
	
	string := 'foobartoobar'.
	self testMenuHandlesNewMenuAppend.
	interface setMenuItemText: secondaryMenu item: 2 itemString: string.
	self should: [(interface getMenuItemText: secondaryMenu item: 2) = string].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/26/2004 13:03'!
testMenuHandlesNewMenuAppendCheckSetItemTextEncoding
	| encoding |
	self testMenuHandlesNewMenuAppend.
	encoding := 37.
	interface setMenuItemTextEncoding: secondaryMenu item: 1 inScriptID: encoding.
	self should: [(interface getMenuItemTextEncoding: secondaryMenu item: 1) = encoding].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/26/2004 16:57'!
testMenuHandlesNewMenuAppendCheckSetItemTextFondID
	| glyph |
	self testMenuHandlesNewMenuAppend.
	glyph := 16r6C.
	interface setMenuItemKeyGlyph: secondaryMenu item: 2 glyph:  glyph.
	self should: [(interface getMenuItemKeyGlyph: secondaryMenu item: 2) = glyph].
	

	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 15:00'!
testMenuHandlesNewMenuAppendCheckSetMark

	self testMenuHandlesNewMenuAppend.
	interface setItemMark: secondaryMenu item: 1 markChar: $x.
	self should: [(interface getItemMark: secondaryMenu item: 1) = $x].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/26/2004 12:50'!
testMenuHandlesNewMenuAppendCheckSetMenuTitle
	| string |
	
	string := 'foobartoobar'.
	self testMenuHandlesNewMenuAppend.
	interface setMenuTitle: secondaryMenu title: string.
	self should: [(interface getMenuTitle: secondaryMenu) = string].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 16:03'!
testMenuHandlesNewMenuAppendCheckSetStyle
	| styles |
	
	self testMenuHandlesNewMenuAppend.
	styles := Set withAll: #( #bold #italic #underline #outline #shadow).
	interface setItemStyle: secondaryMenu item: 1 style: styles.
	self should: [(interface getItemStyle: secondaryMenu item: 1) size = 5].
	styles do: [:style |
		self should: [(interface getItemStyle: secondaryMenu item: 1) includes: style]].



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 14:35'!
testMenuHandlesNewMenuAppendDeleteItem

	self testMenuHandlesNewMenuAppend.
	interface deleteMenuItem: secondaryMenu item: 1.
	self should: [(interface countMenuItems: secondaryMenu) = 1].
	self should: [(interface getMenuItemText: secondaryMenu item: 1) = 'two']



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 14:35'!
testMenuHandlesNewMenuAppendDeleteItem2

	self testMenuHandlesNewMenuAppend.
	interface deleteMenuItem: secondaryMenu item: 2.
	self should: [(interface countMenuItems: secondaryMenu) = 1].
	self should: [(interface getMenuItemText: secondaryMenu item: 1) = 'one']



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'torsten.bergmann 12/16/2008 12:47'!
testMenuHandlesNewMenuAppendInsertItem
	| aItem checkBlock1 checkBlock2 block1 block2 |
	
	self testMenuHandlesNewMenuAppend.
	block1 := [:evt | Beeper beep].
	block2 := [:evt | Beeper beep. Beeper beep].
	aItem := HostSystemMenusMenuItem text: 'three' handler: block1.
	interface insertMenuItem: secondaryMenu item: aItem afterItem: 1.
	aItem := HostSystemMenusMenuItem text: 'four' handler: block2.
	interface insertMenuItem: secondaryMenu item: aItem afterItem: 3.
	checkBlock1 := (HostSystemMenus 
		defaultMenuBarForWindowIndex: 1) getHandlerForMenu: 4 item: 2.
	checkBlock2 := (HostSystemMenus 
		defaultMenuBarForWindowIndex: 1)  getHandlerForMenu: 4 item: 4.
	self should: [checkBlock1 handler == block1 ].
	self should: [checkBlock2 handler == block2 ].
	self should: [(interface countMenuItems: secondaryMenu) = 4].
	self should: [(interface getMenuItemText: secondaryMenu item: 2) = 'three'].
	self should: [(interface getMenuItemText: secondaryMenu item: 4) = 'four']



	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 8/25/2004 12:39'!
testMenuHandlesNewMenuAppendText
	| testString |
	testString := 'testxyz'.
	self testMenuHandlesNewMenuAppend.
	interface appendMenuItemText: secondaryMenu data: testString.


	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/6/2004 17:05'!
testMenuHandlesNewMenuAppendWindowMenu
	interface appendStandardWindowMenu: 0.


	

! !

!HostSystemMenusTest methodsFor: 'testing' stamp: 'JMM 10/15/2004 12:42'!
testMenuHideShowMenu
	self should: [interface isMenuBarVisible: 1].
	interface hideMenuBar: 1.
	self should: [(interface isMenuBarVisible: 1) not].
	interface showMenuBar: 1.
	self should: [interface isMenuBarVisible: 1].
	interface drawMenuBar: 1.
	! !

!HostSystemMenusTest methodsFor: 'utility' stamp: 'JMM 10/21/2004 18:37'!
undoMenuItem
	^1! !

Object subclass: #HostSystemMenus
	instanceVariableNames: 'hostSystemProxy'
	classVariableNames: 'Default DeveloperMode'
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenus commentStamp: 'JMM 10/15/2004 13:02' prior: 0!
This class uses a proxy and a plugin to support access to the host operating system's menu api. 
Most of the work is done in the proxy and the proxy calls  a host OS specific plugin, or  uses FFI or whatever is applicable to make host menus work. 

Most menubar commands take a host window index value. This maps to the host window index value that is used by the host window plugin. This supports windows that support host menu bars. The macintosh has a single menu bar and all uses of windowIndex are later ignored in the macintosh proxy code. 

When menu events are passed up from the VM by a VM that actually generates the events, they are processed in EventSensor>>processMenuEvent: which calls HostSystemMenus>>defaultMenuBarForWindowIndex: N. This returns the proxy that handles the interface to the menu bar for the window that has windowIndex N. It then invokes 	HostSystemMenuProxy>>getHandlerForMenu:item:  to get a block that will act on the invocation of menu N, menu Item M.  See HostSystemMenusMenuItem class>>fakeKeyboardEventBlockascii:unicode: 
for the default blocks definition which defaults to insert the command key keyboard stroke into the event queue. This then mimics command key usage which is being watched for by Morphic/Tweak widgets. 

Structure:
 hostSystemProxy	HostSystemMenusProxy -- points to the proxy class that interfaces to the plugin
 Default				HostSystemMenus -- points to the single instance of HostSystemMenus

The macintosh plugin attempts to validate incoming menu handles. But care still must be taken not to pass in a bogus handle because this will crash the VM. Finalization is used to ensure 'lost' menu proxies are dealt with. 

!

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'JMM 10/12/2004 14:36'!
activeMenuProxyClass
	"Return the concreteHostMenuProxy subclass for the platform on which we are
currently running."

	HostSystemMenusProxy allSubclasses do: [:class |
		class isActiveHostMenuProxyClass ifTrue: [^ class]].

	"no responding subclass; use HostSystemMenusProxy"
	^ HostSystemMenusProxy
! !

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'GabrielOmarCotelli 6/4/2009 20:15'!
clearDefault
	Default := nil! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'JMM 10/1/2004 12:51'!
default
	^Default ifNil: [Default := self new] ifNotNil: [Default]! !

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'JMM 10/12/2004 14:27'!
defaultMenuBarForWindowIndex: aWindowIndex
	^self default defaultMenuBarForWindowIndex: aWindowIndex
! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'pe 9/1/2006 17:55'!
developerMode
	^DeveloperMode ifNil: [DeveloperMode := true] ifNotNil: [DeveloperMode].! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'pe 9/1/2006 17:55'!
developerMode: aBool
	DeveloperMode := aBool.! !

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'GabrielOmarCotelli 6/4/2009 20:15'!
initialize
	"Add me to the system startup list"
	"self initialize"
	self clearDefault.
	Smalltalk 
		addToStartUpList: self
		after: SmalltalkImage! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'JMM 5/15/2006 21:36'!
invokeCmd: aCmd 
	| app |

	app := self default hostSystemProxy application.
	app ifNil: [^self].
	app perform: aCmd ! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'JMM 5/15/2006 21:36'!
invokeCmd: aCmd with: anEvent
	| app |

	app := self default hostSystemProxy application.
	app ifNil: [^self].
	app perform: aCmd with: anEvent! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'JMM 5/15/2006 21:30'!
menuBarControler
	^self default hostSystemProxy! !

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'JMM 10/1/2004 15:15'!
new
	^self basicNew initialize! !

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'JMM 10/12/2004 11:45'!
setDefaultMenuProxyClass
	self default hostSystemProxy: self activeMenuProxyClass new.
	! !

!HostSystemMenus class methodsFor: 'instance creation' stamp: 'GabrielOmarCotelli 6/4/2009 20:16'!
startUp: resuming
	resuming ifFalse: [^self].
	self clearDefault.
	[self setDefaultMenuProxyClass] ifError: [:err :rcvr | ].! !

!HostSystemMenus class methodsFor: 'accessing' stamp: 'pe 9/1/2006 17:56'!
toggleDeveloperMode

	DeveloperMode := DeveloperMode not.! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:08'!
appendMenu: aMenuHandle menuItems: aCollection
	self hostSystemProxy appendMenu: aMenuHandle menuItems: aCollection
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:09'!
checkMenuItem: aMenuHandle item: anInteger checked: aBoolean
	self hostSystemProxy checkMenuItem: aMenuHandle item: anInteger checked: aBoolean! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:36'!
clearMenuBar: aWindowIndex
	self hostSystemProxy clearMenuBar: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:09'!
countMenuItems: aMenuHandle
	^self hostSystemProxy countMenuItems: aMenuHandle! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:36'!
createMenuBar: aWindowIndex
	self hostSystemProxy createMenuBar: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 14:31'!
defaultMenuBarForWindowIndex: aWindowIndex
	^self hostSystemProxy defaultMenuBarForWindowIndex: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:11'!
deleteMenu: aMenuHandle
	self hostSystemProxy deleteMenu: aMenuHandle
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:12'!
deleteMenuItem: aMenuHandle item: aNumber
	self hostSystemProxy deleteMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'finalization' stamp: 'JMM 10/1/2004 13:02'!
destroyEveryThing
	self hostSystemProxy destroyEveryThing! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:12'!
disableMenuItem: aMenuHandle item: aNumber
	self hostSystemProxy disableMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:37'!
disposeMenuBar: aWindowIndex
	self hostSystemProxy disposeMenuBar: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:37'!
drawMenuBar: aWindowIndex
	self hostSystemProxy drawMenuBar: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:13'!
enableMenuItem: aMenuHandle item: aNumber
	self hostSystemProxy enableMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:13'!
getItemCmd: aMenuHandle item: aNumber
	^self hostSystemProxy getItemCmd: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:13'!
getItemIcon: aMenuHandle item: aNumber
	^self hostSystemProxy getItemIcon: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:18'!
getItemMark: aMenuHandle item: aNumber
	^self hostSystemProxy getItemMark: aMenuHandle item: aNumber
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
getItemStyle: aMenuHandle item: aNumber
	^self hostSystemProxy getItemStyle: aMenuHandle item: aNumber
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:19'!
getMenuHandle: aMenuID
	^self hostSystemProxy getMenuHandle: aMenuID! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:19'!
getMenuID: aMenuHandle
	^self hostSystemProxy getMenuID: aMenuHandle! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:19'!
getMenuItemText: aMenuHandle item: aNumber
	^self hostSystemProxy getMenuItemText: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:19'!
getMenuTitle: aMenuHandle
	^self hostSystemProxy getMenuTitle: aMenuHandle! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:37'!
hideMenuBar: aWindowIndex
	self hostSystemProxy hideMenuBar: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing' stamp: 'JMM 10/12/2004 14:26'!
hostSystemProxy
	hostSystemProxy ifNil: [self class setDefaultMenuProxyClass].
	^hostSystemProxy! !

!HostSystemMenus methodsFor: 'accessing' stamp: 'JMM 10/1/2004 12:52'!
hostSystemProxy: anObject
	hostSystemProxy := anObject! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:19'!
insertMenu: aMenuHandle beforeID: anId
	self hostSystemProxy insertMenu: aMenuHandle beforeID: anId! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:15'!
insertMenuItem: menuHandleOop item: anItem afterItem: anInteger
	self hostSystemProxy insertMenuItem: menuHandleOop item: anItem afterItem: anInteger

! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:37'!
isMenuBarVisible: aWindowIndex
	^self hostSystemProxy isMenuBarVisible: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:20'!
isMenuItemEnabled: aMenuHandle item: aNumber
	^self hostSystemProxy isMenuItemEnabled: aMenuHandle item: aNumber! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:37'!
newMenu: xmenuID menuTitle: menuTitle
	^self hostSystemProxy newMenu: xmenuID menuTitle: menuTitle
	! !

!HostSystemMenus methodsFor: 'accessing' stamp: 'JMM 10/1/2004 13:07'!
setHandlerForMenu: aMenuID item: anItem handler: aHandler
	self hostSystemProxy setHandlerForMenu: aMenuID item: anItem handler: aHandler
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:37'!
setItemCmd: menuHandleOop item: anInteger cmdChar: anIntegerCmdChar
	self hostSystemProxy setItemCmd: menuHandleOop item: anInteger cmdChar: anIntegerCmdChar

! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:37'!
setItemMark: menuHandleOop item: anInteger markChar: aMarkChar
	self hostSystemProxy  setItemMark: menuHandleOop item: anInteger markChar: aMarkChar

	
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:38'!
setItemStyle: menuHandleOop item: anInteger style: aStyle
	self hostSystemProxy setItemStyle: menuHandleOop item: anInteger style: aStyle

! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:38'!
setMenuItemHierarchicalID: menuHandleOop item: anInteger hierID: aMenuID
	self hostSystemProxy setMenuItemHierarchicalID: menuHandleOop item: anInteger hierID: aMenuID
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:17'!
setMenuItemModifiers: menuHandleOop item: anInteger inModifiers: aUInt8
	self hostSystemProxy setMenuItemModifiers: menuHandleOop item: anInteger inModifiers: aUInt8
! !

!HostSystemMenus methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:38'!
setMenuTitle: menuHandleOop  title: aMenuText
	self hostSystemProxy setMenuTitle: menuHandleOop  title: aMenuText

! !

!HostSystemMenus methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:37'!
showMenuBar: aWindowIndex
	self hostSystemProxy showMenuBar: aWindowIndex! !

!HostSystemMenus methodsFor: 'accessing' stamp: 'JMM 8/3/2006 17:26'!
toggleReaderMode: aBool! !

Object subclass: #HostSystemMenusMenuItem
	instanceVariableNames: 'icon mark style cmd disabled text handler shift'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusMenuItem commentStamp: 'JMM 10/22/2004 11:04' prior: 0!
Holds on to information about a menu item, this allows you to create and populate a menu item which is then handed to the HostSystemMenus classes to actually build the menu item. It does not refect the real-time state of the menu item since changes to the menu items via HostSystemMenus are not recorded. For example to understand the actual enabled/disabled state you must make an api call to host os to get the actual state, the same applies to all other attributes. After creation the only attribute used is the handler which points to the block to execute when a menu item is activated.

icon 		pointer to icon information
mark 		mark character (ascii value)
style 		pointer to style information
cmd 		command magic number
disabled 	true if disabled 
text 		text of the menu item
handler 	pointer to the block that gets executed when you invoke the menu item. 
!

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 10/18/2004 08:58'!
activeMenuItemClass
	"Return the HostSystemMenusMenuItem subclass for the platform on which we are
currently running."

	HostSystemMenusMenuItem allSubclasses do: [:class |
		class isActiveHostMenuItemClass ifTrue: [^ class]].

	"no responding subclass; use HostSystemMenusMenuItem"
	^ HostSystemMenusMenuItem

! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 10/18/2004 08:58'!
defaultMenuItem
	^ self activeMenuItemClass basicNew initialize.
! !

!HostSystemMenusMenuItem class methodsFor: 'handlers' stamp: 'JMM 10/4/2004 17:37'!
fakeKeyboardEventBlockascii: anAsciiValue unicode: aUnicodeValue
	^[:evt | HostSystemMenusMenuItem fakeKeyboardEventBlockasciiActual: anAsciiValue unicode: aUnicodeValue event: evt]! !

!HostSystemMenusMenuItem class methodsFor: 'handlers' stamp: 'JMM 3/2/2006 16:30'!
fakeKeyboardEventBlockascii: anAsciiValue unicode: aUnicodeValue virtualKey: aVirtualKeyValue
	^[:evt | HostSystemMenusMenuItem fakeKeyboardEventBlockasciiActual: anAsciiValue unicode: aUnicodeValue event: evt virtualKey: aVirtualKeyValue]! !

!HostSystemMenusMenuItem class methodsFor: 'handlers' stamp: 'michael.rueger 5/11/2009 19:57'!
fakeKeyboardEventBlockasciiActual: anAsciiValue unicode: aUnicodeValue event: evt
	|event |
		event := Array new: 8.
		event at: 1 put: 2 "EventTypeKeyboard";
		  at: 2 put: Time millisecondClockValue;
		  at: 3 put: aUnicodeValue asInteger;  
		  at: 4 put: 1; "key down"
		  at: 5 put: 8; "modifier keys  (CmmandKeyBit)"
		  at: 8 put: (evt at: 8).
		Sensor handleEvent: event.
		
		event := Array new: 8.
		event at: 1 put: 2 "EventTypeKeyboard";
		  at: 2 put: Time millisecondClockValue;
		  at: 3 put: anAsciiValue asInteger;
		  at: 4 put: 0; "key char"
		  at: 5 put: 8; "modifier keys  (CmmandKeyBit)"
		  at: 8 put: (evt at: 8).
		Sensor handleEvent: event.

		event := Array new: 8.
		event at: 1 put: 2 "EventTypeKeyboard";
		  at: 2 put: Time millisecondClockValue;
		  at: 3 put: aUnicodeValue asInteger;
		  at: 4 put: 2; "key press/release"
		  at: 5 put: 64; "modifier keys  (CmmandKeyBit)"
		  at: 8 put: (evt at: 8).
		Sensor handleEvent: event! !

!HostSystemMenusMenuItem class methodsFor: 'handlers' stamp: 'michael.rueger 5/11/2009 19:57'!
fakeKeyboardEventBlockasciiActual: anAsciiValue unicode: aUnicodeValue event: evt virtualKey: aVirtualKeyValue
	|event |
	
		event := Array new: 8.
		event at: 1 put: 2 "EventTypeKeyboard";
		  at: 2 put: Time millisecondClockValue; 
		  at: 3 put: aVirtualKeyValue asInteger;  
		  at: 4 put: 1; "key down"
		  at: 5 put: 8; "modifier keys  (CmmandKeyBit)"
		  at: 8 put: (evt at: 8).
		Sensor handleEvent: event.
		
		event := Array new: 8.
		event at: 1 put: 2 "EventTypeKeyboard";
		  at: 2 put: Time millisecondClockValue;
		  at: 3 put: anAsciiValue asInteger;
		  at: 4 put: 0; "key char"
		  at: 5 put: 8; "modifier keys  (CmmandKeyBit)"
		  at: 6 put: aUnicodeValue asInteger; "virtual key code"
		  at: 8 put: (evt at: 8).
		Sensor handleEvent: event.

		event := Array new: 8.
		event at: 1 put: 2 "EventTypeKeyboard";
		  at: 2 put: Time millisecondClockValue;
		  at: 3 put: aVirtualKeyValue asInteger;
		  at: 4 put: 2; "key press/release"
		  at: 5 put: 64; "modifier keys  (CmmandKeyBit)"
		  at: 8 put: (evt at: 8).
		Sensor handleEvent: event! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 9/22/2004 15:21'!
menuString: aString 
	^self text: aString handler: self nullBlock! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 10/18/2004 14:52'!
menuString: aString  handler: aHandler
	^self text: aString handler: aHandler! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 5/14/2006 02:19'!
menuString: aString keyboardKey: aKey
	^self text: aString cmd: aKey asUppercase handler: 
		(self fakeKeyboardEventBlockascii: aKey unicode: aKey )! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 5/14/2006 02:20'!
menuString: aString keyboardKey: aKey handler: aHandler
	^self text: aString cmd: aKey asUppercase handler: aHandler! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 9/18/2006 14:51'!
menuString: aString keyboardKey: aKey shift: state handler: aHandler
	^self text: aString cmd: aKey asUppercase shift: state handler: aHandler! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 5/14/2006 02:19'!
menuString: aString keyboardKey: aKey virtualKeyValue: aVirtualKeyValue 
	^self text: aString cmd: aKey asUppercase handler: 
		(self fakeKeyboardEventBlockascii: aKey unicode: aKey virtualKey: aVirtualKeyValue)! !

!HostSystemMenusMenuItem class methodsFor: 'handlers' stamp: 'JMM 8/30/2004 16:52'!
nullBlock
	^[:evt | ]! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'John M McIntosh 10/31/2008 19:28'!
subMenu: aMenuId menuString: aString 
	| item |
	
	item := self text: aString handler: self nullBlock.
	item mark: aMenuId.
	item cmd: 16r1B asCharacter.
	^item.! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 8/30/2004 16:56'!
text: aTextItem cmd: aCmd handler: aHandlerBlock
	| resolvedClassInstance |
	
	resolvedClassInstance := self defaultMenuItem.
	resolvedClassInstance text: aTextItem.
	resolvedClassInstance cmd: aCmd.
	resolvedClassInstance handler: aHandlerBlock.
	^resolvedClassInstance! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 9/18/2006 14:51'!
text: aTextItem cmd: aCmd shift: state handler: aHandlerBlock
	| resolvedClassInstance |
	
	resolvedClassInstance := self defaultMenuItem.
	resolvedClassInstance text: aTextItem.
	resolvedClassInstance cmd: aCmd.
	resolvedClassInstance shift: state.
	resolvedClassInstance handler: aHandlerBlock.
	^resolvedClassInstance! !

!HostSystemMenusMenuItem class methodsFor: 'instance creation' stamp: 'JMM 8/30/2004 16:56'!
text: aTextItem handler: aHandlerBlock
	| resolvedClassInstance |
	
	resolvedClassInstance := self defaultMenuItem.
	resolvedClassInstance text: aTextItem.
	resolvedClassInstance handler: aHandlerBlock.
	^resolvedClassInstance! !

!HostSystemMenusMenuItem methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:39'!
appleMark
	^nil! !

!HostSystemMenusMenuItem methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:39'!
checkMark
^nil! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
cmd
	"Answer the value of cmd"

	^ cmd! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
cmd: anObject
	"Set the value of cmd"

	cmd := anObject! !

!HostSystemMenusMenuItem methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:40'!
commandMark
^nil! !

!HostSystemMenusMenuItem methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:40'!
diamondMark
^nil! !

!HostSystemMenusMenuItem methodsFor: 'attributes' stamp: 'JMM 8/25/2004 10:30'!
disable
	disabled := true.! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
disabled
	"Answer the value of disabled"

	^ disabled! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
disabled: anObject
	"Set the value of disabled"

	disabled := anObject! !

!HostSystemMenusMenuItem methodsFor: 'attributes' stamp: 'JMM 8/25/2004 10:30'!
enable
	disabled := false.! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/30/2004 16:53'!
handler
	^handler! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/30/2004 16:54'!
handler: aHandlerBlock
	handler := aHandlerBlock! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
icon
	"Answer the value of icon"

	^ icon! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
icon: anObject
	"Set the value of icon"

	icon := anObject! !

!HostSystemMenusMenuItem methodsFor: 'initialize-release' stamp: 'alain.plantec 5/28/2009 09:57'!
initialize
	super initialize.
	self enable.
	self mark: self noMark.
	self style: Set new.
	! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
mark
	"Answer the value of mark"

	^ mark! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
mark: anObject
	"Set the value of mark"

	mark := anObject! !

!HostSystemMenusMenuItem methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:37'!
noMark
	^nil! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 9/18/2006 14:49'!
shift
	^shift == true! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 9/18/2006 14:49'!
shift: aBoolean
	shift := aBoolean! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
style
	"Answer the value of style"

	^ style! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:21'!
style: anObject
	"Set the value of style"

	style := anObject! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 13:08'!
styleAdd: aStyle

	style add: aStyle! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 13:08'!
styleRemove: aStyle

	style remove: aStyle ifAbsent: []! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:23'!
text
	"Answer the value of text"

	^ text! !

!HostSystemMenusMenuItem methodsFor: 'accessing' stamp: 'JMM 8/25/2004 10:23'!
text: anObject
	"Set the value of text"

	text := anObject! !

HostSystemMenusMenuItem subclass: #HostSystemMenusMenuItemMac
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusMenuItemMac commentStamp: 'JMM 10/22/2004 10:20' prior: 0!
mac specific information, contains the magic constants for the mark characters. !

!HostSystemMenusMenuItemMac class methodsFor: 'instance creation' stamp: 'JMM 1/15/2007 13:02'!
isActiveHostMenuItemClass
		^SmalltalkImage current platformName  = 'Mac OS'! !

!HostSystemMenusMenuItemMac methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:38'!
appleMark
	^20! !

!HostSystemMenusMenuItemMac methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:38'!
checkMark
	^18! !

!HostSystemMenusMenuItemMac methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:38'!
commandMark
	^17! !

!HostSystemMenusMenuItemMac methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:38'!
diamondMark
	^19! !

!HostSystemMenusMenuItemMac methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:41'!
hierMenu
	^-1! !

!HostSystemMenusMenuItemMac methodsFor: 'constants' stamp: 'JMM 8/25/2004 10:36'!
noMark
	^0! !

Object subclass: #HostSystemMenusProxy
	instanceVariableNames: 'application'
	classVariableNames: 'Registry'
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusProxy commentStamp: 'JMM 10/22/2004 10:24' prior: 0!
Proxy for the host api menu structure. 
All calls are managed by subclasses which support the menu API.
What is implemented is the finalization logic to ensure GCed menus are disposed of if the user forgets to dispose of the menu before he 
forgets about the instance of this class. 

!

HostSystemMenusProxy subclass: #HostSystemMenusMacOS9
	instanceVariableNames: 'isVMMenuBar menuBar menus'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusMacOS9 commentStamp: 'JMM 10/15/2004 13:07' prior: 0!
Interface to the OS-9 classic menu bar macintosh plugin. 

Structure:
 isVMMenuBar	Boolean -- true if this menu bar was built by the VM
 menuBar		MenubarHandle -- The  magic number identifying the menubar
 menus			Dictionary -- Holds onto the definitions for each menu item in the menubar

Any further useful comments about the general approach of this implementation.
isVMMenuBar menuBar menus windowIndex !

!HostSystemMenusMacOS9 classSide methodsFor: 'instance creation' stamp: 'JMM 1/15/2007 12:00'!
isActiveHostMenuProxyClass
"Am I active?"
	^SmalltalkImage current  platformName  = 'Mac OS' and: [SmalltalkImage current  osVersion asInteger < 1000]! !

!HostSystemMenusMacOS9 classSide methodsFor: 'instance creation' stamp: 'JMM 10/1/2004 15:15'!
new
	^self basicNew initialize! !

!HostSystemMenusMacOS9 methodsFor: 'utility' stamp: 'adrian_lienhard 7/18/2009 15:57'!
alterFileMenu 
	| fileMenu items |	

	fileMenu := self getMenuHandle: 2.
	items := OrderedCollection 
			with: (HostSystemMenusMenuItem menuString: 'Quit do not save')
			with: (HostSystemMenusMenuItem menuString: '-')
			with: (HostSystemMenusMenuItem menuString: 'Save' 
				handler: [:evt | Smalltalk snapshot: true andQuit: false ] )
			with: (HostSystemMenusMenuItem menuString: 'Save As...' 
				handler: [:evt | SmalltalkImage current saveAs])
			with: (HostSystemMenusMenuItem menuString: '-')
			with: (HostSystemMenusMenuItem menuString: 'Quit VM '
				handler: [:evt | SmalltalkImage current snapshot:
			(self confirm: 'Save changes before quitting?'
				orCancel: [^ self])
				andQuit: true]).
	(self countMenuItems: fileMenu) > 1 
		ifTrue: 
			[1 to: items size do: 
				[:i | self setHandlerForMenu: 2 item: i  handler: (items at: i)]]
		ifFalse:
			[self deleteMenuItem: fileMenu item: 1.
			self appendMenu: fileMenu menuItems: items].
	
	
	
	! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'John M McIntosh 10/31/2008 19:09'!
appendMenu: aMenuHandle menuItems: aCollection
	| str255  |
	
	aCollection do: [:e | |subCollection|
		subCollection := OrderedCollection with: e.
		str255 := self buildDataStringForAppendOrInsert: subCollection.
		self resolveAppendOfMenuItems: subCollection forMenuHandle: aMenuHandle.
		self primAppendMenu: aMenuHandle data: str255].
 ! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 11:08'!
appendMenuItemText: menuHandleOop data: menuItemText
	| str255 |
	
	str255 := self convertToStr255: menuItemText.
 	^self primAppendMenuItemText: menuHandleOop data: str255! !

!HostSystemMenusMacOS9 methodsFor: 'initialize-release' stamp: 'JMM 10/18/2004 09:21'!
appendStandardWindowMenu: inOptions
	^self
! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'John M McIntosh 10/31/2008 19:09'!
buildDataStringForAppendOrInsert: aCollection
	| first str icon mark style cmd |

	first := true.
	str := WriteStream on: (String new: 80).
	aCollection do: [:m |
		first ifFalse: [str nextPutAll: ';'].
		first ifTrue: [first := false].
		str nextPutAll: m text.
		(icon := m icon) ifNotNil: [str nextPutAll: '^';nextPutAll: icon printString].
		(mark := m mark) ifNotNil: [str nextPutAll: '!!';nextPut: mark asCharacter].
		(style := m style) ifNotNil: [str nextPutAll: (self resolveStyle: style)].
		(cmd := m cmd) ifNotNil: [str nextPutAll: '/';nextPut: cmd].
		m disabled ifTrue: [str nextPutAll: '('].
		].
	^self convertToStr255: str contents.
	! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'JMM 8/25/2004 16:19'!
buildModifers: integer
	| modifiers |
	integer isZero ifTrue: [^Set with: #command].
	modifiers := Set new.
	(integer bitAnd: 1) > 0 ifTrue: [modifiers add: #shift].
	(integer bitAnd: 2) > 0 ifTrue: [modifiers add: #option].
	(integer bitAnd: 4) > 0 ifTrue: [modifiers add: #control].
	(integer bitAnd: 8) > 0 ifTrue: [modifiers add: #nocommand].
	^modifiers! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'JMM 8/25/2004 15:45'!
buildStyle: integer
	| styles |
	styles := Set new.
	(integer bitAnd: 1) > 0 ifTrue: [styles add: #bold].
	(integer bitAnd: 2) > 0 ifTrue: [styles add: #italic].
	(integer bitAnd: 4) > 0 ifTrue: [styles add: #underline].
	(integer bitAnd: 8) > 0 ifTrue: [styles add: #outline].
	(integer bitAnd: 16) > 0 ifTrue: [styles add: #shadow].
	^styles! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 12:29'!
checkMenuItem: aMenuHandle item: anInteger checked: aBoolean
	self primCheckMenuItem: aMenuHandle item: anInteger checked: aBoolean

! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:40'!
clearMenuBar: aWindowIndex
	self primClearMenuBar! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'JMM 8/26/2004 11:10'!
convertToStr255: aString
	| str255 size |
	
	str255 := ByteArray new: 256.
	size := aString size.
	size > 255 ifTrue: [self error: 'String is too long'].
	str255 byteAt: 1 put: size.
	str255 replaceFrom: 2 to: size + 1 with: aString startingAt: 1.
	^str255
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:09'!
countMenuItems: aMenuHandle
	^self primCountMenuItems: aMenuHandle! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:40'!
createMenuBar: aWindowIndex
	! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/18/2004 14:37'!
deleteMenu: aMenuHandle
		| menuID |
	menuID := self getMenuID: aMenuHandle.
	self menus removeKey: menuID ifAbsent: [nil].
	self primDeleteMenu: menuID.
	self primDisposeMenu: aMenuHandle.
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:11'!
deleteMenuItem: aMenuHandle item: aNumber
	self primDeleteMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'initialize-release' stamp: 'JMM 10/15/2004 12:41'!
destroyEveryThing
	self disposeMenuBar: 1.
	menuBar ifNotNil: 
			[menuBar := nil]! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:12'!
disableMenuItem: aMenuHandle item: aNumber
	self primDisableMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 14:25'!
disposeMenuBar: aWindowIndex
	(self isVMMenuBar: aWindowIndex) ifTrue: [^self].
	menuBar ifNotNil: [self primDisposeMenuBar: menuBar].
	menuBar := nil! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/1/2004 13:04'!
drawMenuBar
	self primDrawMenuBar! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 13:08'!
drawMenuBar: aWindowIndex
	self primDrawMenuBar! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 19:10'!
enableMenuItem: aMenuHandle item: aNumber
	self  primEnableMenuItem: aMenuHandle item: aNumber.! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/18/2004 15:02'!
getHandlerForMenu: aMenuID item: anItem
	| menu menuItemHandler |
	
	menu := self menus at: aMenuID ifAbsentPut: [Dictionary new].
	menuItemHandler := menu at: anItem ifAbsentPut: [HostSystemMenusMenuItem menuString: ''].
	^menuItemHandler! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:13'!
getItemCmd: aMenuHandle item: aNumber
	^(self primGetItemCmd: aMenuHandle item: aNumber) asCharacter! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:13'!
getItemIcon: aMenuHandle item: aNumber
	^self primGetItemIcon: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
getItemMark: aMenuHandle item: aNumber
	^(self primGetItemMark: aMenuHandle item: aNumber) asCharacter! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 11:12'!
getItemStyle: aMenuHandle item: aNumber
	^self buildStyle: (self primGetItemStyle: aMenuHandle item: aNumber)
	! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
getMenuHandle: aMenuID
	^self primGetMenuHandle: aMenuID! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
getMenuID: aMenuHandle
	^self primGetMenuID: aMenuHandle! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/23/2004 12:32'!
getMenuItemCommandID: aMenuHandle item: aNumber
	^self primGetMenuItemCommandID: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/23/2004 12:34'!
getMenuItemFontID: aMenuHandle item: aNumber
	^self primGetMenuItemFontID: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 15:52'!
getMenuItemHierarchicalID: menuHandleOop item: anInteger 
	^self primGetMenuItemHierarchicalID: menuHandleOop item: anInteger ! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/23/2004 12:39'!
getMenuItemKeyGlyph: aMenuHandle item: aNumber
	^self primGetMenuItemKeyGlyph: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/25/2004 16:20'!
getMenuItemModifiers: aMenuHandle item: aNumber
	^self buildModifers: (self primGetMenuItemModifiers: aMenuHandle item: aNumber)! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
getMenuItemText: aMenuHandle item: aNumber
	^self primGetMenuItemText: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/23/2004 12:59'!
getMenuItemTextEncoding: aMenuHandle item: aNumber
	^self primGetMenuItemTextEncoding: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
getMenuTitle: aMenuHandle
	^self primGetMenuTitle: aMenuHandle! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:41'!
hideMenuBar: aWindowIndex
	self primHideMenuBar! !

!HostSystemMenusMacOS9 methodsFor: 'initialize-release' stamp: 'JMM 10/18/2004 09:21'!
initialize
	| menuHandle |
	super initialize.
	isVMMenuBar := true.
	menus := Dictionary new.
	self rebuildFromVMInstalledMenu.
	self appendStandardWindowMenu: 0.
	self reworkFileMenu.
	self menuBar.
	menuHandle := self getMenuHandle: 3.
	self enableMenuItem: menuHandle item: 1.
	self enableMenuItem: menuHandle item: 3.
	self enableMenuItem: menuHandle item: 4.
	self enableMenuItem: menuHandle item: 5.
	self drawMenuBar.
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 12:38'!
insertFontResMenu: menuHandleOop afterItem: afterItemInteger scriptFilter:  scriptFilterInteger
	self primInsertFontResMenu: menuHandleOop afterItem: afterItemInteger scriptFilter:  scriptFilterInteger

! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:14'!
insertMenu: aMenuHandle beforeID: anId
	self primInsertMenu: aMenuHandle beforeID: anId! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 9/2/2004 22:04'!
insertMenuItem: menuHandleOop item: aItem afterItem: anInteger
	| str255 |
	str255 := self buildDataStringForAppendOrInsert: (OrderedCollection with: aItem).
	self resolveInsertOfMenuItem: aItem afterItem: anInteger forMenuHandle: menuHandleOop.
	self primInsertMenuItem: menuHandleOop itemString: str255 afterItem: anInteger.

! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 8/23/2004 14:11'!
invalMenuBar
	self primInvalMenuBar! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:42'!
isMenuBarVisible: aWindowIndex
	^self primIsMenuBarVisible! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:15'!
isMenuItemEnabled: aMenuHandle item: aNumber
	^self primIsMenuItemEnabled: aMenuHandle item: aNumber! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/1/2004 12:59'!
isVMMenuBar: anObject 
	"Set the value of isVMMenuBar"

	isVMMenuBar := anObject! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:32'!
menuBar
	menuBar ifNil: 
			[menuBar := self primGetMenuBar].
	^menuBar! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/1/2004 12:59'!
menus
	^menus! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 11:09'!
newMenu: menuID menuTitle: menuTitle
	| str255 |
	
	str255 := self convertToStr255: menuTitle.
 	^self primNewMenu: menuID menuTitle: str255! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 11:20'!
primAppendMenu: menuHandleOop data: str255
	<primitive: 'primitiveAppendMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 12:12'!
primAppendMenuItemText: menuHandleOop data: str255
	<primitive: 'primitiveAppendMenuItemText' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 14:21'!
primCheckMenuItem: aMenuHandle item: anInteger checked: aBoolean
	<primitive: 'primitiveCheckMenuItem' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/24/2004 17:59'!
primClearMenuBar
	<primitive: 'primitiveClearMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 11:45'!
primCountMenuItems: aMenuHandle
	<primitive: 'primitiveCountMenuItems' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/24/2004 17:24'!
primDeleteMenu: aMenuID
	<primitive: 'primitiveDeleteMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 14:30'!
primDeleteMenuItem: aMenuHandle item: anInteger
	<primitive: 'primitiveDeleteMenuItem' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 14:31'!
primDisableMenuItem: aMenuHandle item: anInteger
	<primitive: 'primitiveDisableMenuItem' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/24/2004 17:26'!
primDisposeMenu: aMenuHandle
	<primitive: 'primitiveDisposeMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 10:24'!
primDisposeMenuBar: aMenuBar
	<primitive: 'primitiveDisposeMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:15'!
primDrawMenuBar
	<primitive: 'primitiveDrawMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 14:29'!
primEnableMenuItem: aMenuHandle item: anInteger
	<primitive: 'primitiveEnableMenuItem' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 10/7/2004 12:18'!
primGetIndMenuWithCommandID: aMenuHandle commandID: aCommandID
	<primitive: 'primitiveGetIndMenuWithCommandID' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:51'!
primGetItemCmd: aMenuHandle item: anInteger
	<primitive: 'primitiveGetItemCmd' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:58'!
primGetItemIcon: aMenuHandle item: anInteger
	<primitive: 'primitiveGetItemIcon' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 14:02'!
primGetItemMark: aMenuHandle item: anInteger
	<primitive: 'primitiveGetItemMark' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 14:08'!
primGetItemStyle: aMenuHandle item: anInteger
	<primitive: 'primitiveGetItemStyle' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 09:22'!
primGetMenuBar
	<primitive: 'primitiveGetMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 10:31'!
primGetMenuHandle: aMenuHandle
	<primitive: 'primitiveGetMenuHandle' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/24/2004 17:42'!
primGetMenuID: aMenuHandle
	<primitive: 'primitiveGetMenuID' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 13:17'!
primGetMenuItemFontID: menuHandleOop item: anInteger 
	<primitive: 'primitiveGetMenuItemFontID' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 15:52'!
primGetMenuItemHierarchicalID: menuHandleOop item: anInteger 
	<primitive: 'primitiveGetMenuItemHierarchicalID' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 12:39'!
primGetMenuItemKeyGlyph: aMenuHandle item: anInteger
	<primitive: 'primitiveGetMenuItemKeyGlyph' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 12:50'!
primGetMenuItemModifiers: aMenuHandle item: anInteger
	<primitive: 'primitiveGetMenuItemModifiers' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 12:16'!
primGetMenuItemText: aMenuHandle item: anInteger
	<primitive: 'primitiveGetMenuItemText' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:02'!
primGetMenuItemTextEncoding: aMenuHandle item: anInteger
	<primitive: 'primitiveGetMenuItemTextEncoding' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 12:04'!
primGetMenuTitle: aMenuHandle
	<primitive: 'primitiveGetMenuTitle' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:12'!
primHideMenuBar
	<primitive: 'primitiveHideMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 16:16'!
primHiliteMenu: menuID 
	<primitive: 'primitiveHiliteMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 12:38'!
primInsertFontResMenu: menuHandleOop afterItem: afterItemInteger scriptFilter:  scriptFilterInteger
	<primitive: 'primitiveInsertFontResMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 15:25'!
primInsertMenu: aMenuHandle beforeID: anId
	<primitive: 'primitiveInsertMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 14:39'!
primInsertMenuItem: aMenuHandle itemString: str255 afterItem: anInteger
	<primitive: 'primitiveInsertMenuItem' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 14:10'!
primInvalMenuBar
	<primitive: 'primitiveInvalMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:24'!
primIsMenuBarVisible
	<primitive: 'primitiveIsMenuBarVisible' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 14:23'!
primIsMenuItemEnabled: aMenuHandle item: anInteger
	<primitive: 'primitiveIsMenuItemEnabled' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 15:08'!
primNewMenu: aMenuID menuTitle: menuTitle
	<primitive: 'primitiveNewMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 14:53'!
primSetItemCmd: menuHandleOop item: anInteger cmdChar: anIntegerCmdChar
	<primitive: 'primitiveSetItemCmd' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 14:59'!
primSetItemMark: menuHandleOop item: anInteger markChar: aMarkChar
	<primitive: 'primitiveSetItemMark' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 15:44'!
primSetItemStyle: menuHandleOop item: anInteger styleParameter: chStyleInteger
	<primitive: 'primitiveSetItemStyle' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 16:17'!
primSetMenuBar: menuHandleOop
	<primitive: 'primitiveSetMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 16:05'!
primSetMenuItemCommandID: menuHandleOop item: anInteger menuCommand:  inCommandID
	<primitive: 'primitiveSetMenuItemCommandID' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 13:16'!
primSetMenuItemFontID: menuHandleOop item: anInteger fontID: aFontIDInteger  
	<primitive: 'primitiveSetMenuItemFontID' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 14:49'!
primSetMenuItemHierarchicalID: menuHandleOop item: anInteger hierID: aMenuID
	<primitive: 'primitiveSetMenuItemHierarchicalID' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 16:00'!
primSetMenuItemKeyGlyph: menuHandleOop item: anInteger glyph:  inGlyphInteger
	<primitive: 'primitiveSetMenuItemKeyGlyph' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/25/2004 16:13'!
primSetMenuItemModifiers: menuHandleOop item: anInteger inModifiers: aUInt8
	<primitive: 'primitiveSetMenuItemModifiers' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 10:58'!
primSetMenuItemText: menuHandleOop item: anInteger  itemString: str255
	<primitive: 'primitiveSetMenuItemText' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 12:49'!
primSetMenuItemTextEncoding: menuHandleOop item: anInteger inScriptID: aTextEncodingOop
	<primitive: 'primitiveSetMenuItemTextEncoding' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/26/2004 12:46'!
primSetMenuTitle: menuHandleOop  title: str255
	<primitive: 'primitiveSetMenuTitle' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'system primitives' stamp: 'JMM 8/23/2004 13:08'!
primShowMenuBar
	<primitive: 'primitiveShowMenuBar' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOS9 methodsFor: 'initialize-release' stamp: 'JMM 10/18/2004 14:17'!
rebuildFromVMInstalledMenu
	| editMenu fileMenuID editMenuID fileMenu |

	fileMenuID := 2.
	editMenuID := 3.
	editMenu := OrderedCollection 
		with: (HostSystemMenusMenuItem menuString: 'Undo' keyboardKey: $z)
		with: (HostSystemMenusMenuItem menuString: '_')
		with: (HostSystemMenusMenuItem menuString: 'Cut' keyboardKey: $x)
		with: (HostSystemMenusMenuItem menuString: 'Copy' keyboardKey: $c)
		with: (HostSystemMenusMenuItem menuString: 'Paste' keyboardKey: $v)
		with: (HostSystemMenusMenuItem menuString: 'Clear').
	fileMenu := OrderedCollection 
		with: (HostSystemMenusMenuItem menuString: 'Quit do not save').
	1 to: fileMenu size do: 
		[:i | self setHandlerForMenu: fileMenuID item: i  handler: (fileMenu at: i)].
	1 to: editMenu size do: 
		[:i | self setHandlerForMenu: editMenuID item: i  handler: (editMenu at: i)].

	
	! !

!HostSystemMenusMacOS9 methodsFor: 'handlers' stamp: 'JMM 10/18/2004 14:17'!
resolveAppendOfMenuItems: aCollection forMenuHandle: aMenuHandle
	| previousItems menuID |
	
	previousItems := self countMenuItems: aMenuHandle.
	menuID := self getMenuID:  aMenuHandle.
	1 to: aCollection size do: 
		[:i | self setHandlerForMenu: menuID item: i + previousItems handler: (aCollection at: i)]
	! !

!HostSystemMenusMacOS9 methodsFor: 'handlers' stamp: 'JMM 10/18/2004 14:17'!
resolveInsertOfMenuItem: aMenuItem afterItem: anIndex forMenuHandle: aMenuHandle
	| menuID count workList item |
	
	menuID := self getMenuID:  aMenuHandle.
	count := (self menus at: menuID) size.
	workList := OrderedCollection new. 
	1 to: count do: [:i |
		item := self getHandlerForMenu: menuID item: i.
		i = (anIndex+1) ifTrue: [workList add: aMenuItem].
		workList add: item].
	count = anIndex ifTrue: [workList add: aMenuItem].
	1 to: count + 1 do: [:i |
		self setHandlerForMenu: menuID item: i handler: (workList at: i)]
	! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'JMM 8/25/2004 16:35'!
resolveModifiersInteger: modifers
	
	| integer |
	integer := 0.
	#(#shift 1 #option 2 #control 4 #nocommand 8) 
		pairsDo: [:style :bitOffset |
			(modifers includes: style) ifTrue: [integer := integer bitOr: bitOffset]].
	^integer
! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'JMM 8/25/2004 11:41'!
resolveStyle: aStyle
	| string |
	
	string := String new.
	aStyle do: [:s |
			string := string,'<'.
			s = #bold ifTrue: [string := string,'B'].
			s = #italic ifTrue: [string := string,'I'].
			s = #underline ifTrue: [string := string,'U'].
			s = #outline ifTrue: [string := string,'O'].
			s = #shadow ifTrue: [string := string,'S']].
	^string.
! !

!HostSystemMenusMacOS9 methodsFor: 'translation' stamp: 'JMM 8/25/2004 16:01'!
resolveStyleInteger: aStyle
	
	| integer |
	integer := 0.
	#(#bold 1 #italic 2 #underline 4 #outline 8 #shadow 16) 
		pairsDo: [:style :bitOffset |
			(aStyle includes: style) ifTrue: [integer := integer bitOr: bitOffset]].
	^integer
! !

!HostSystemMenusMacOS9 methodsFor: 'utility' stamp: 'JMM 10/18/2004 17:34'!
reworkFileMenu
	self alterFileMenu! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:06'!
setHandlerForMenu: aMenuID item: anItem handler: aHandler
	| menu |
	
	menu := self menus at: aMenuID ifAbsentPut: [Dictionary new].
	menu at: anItem put: aHandler


! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:16'!
setItemCmd: menuHandleOop item: anInteger cmdChar: anIntegerCmdChar
	self primSetItemCmd: menuHandleOop item: anInteger cmdChar: anIntegerCmdChar asCharacter asInteger
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:16'!
setItemMark: menuHandleOop item: anInteger markChar: aMarkChar
	self primSetItemMark: menuHandleOop item: anInteger markChar: aMarkChar asCharacter asInteger
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:16'!
setItemStyle: menuHandleOop item: anInteger style: aStyle
	| styleInteger |
	
	styleInteger := self resolveStyleInteger: aStyle.
	self primSetItemStyle: menuHandleOop item: anInteger styleParameter: styleInteger
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:16'!
setMenuItemCommandID: menuHandleOop item: anInteger menuCommand:  inCommandID
	self primSetMenuItemCommandID: menuHandleOop item: anInteger menuCommand:  inCommandID  asInteger
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 13:17'!
setMenuItemFontID: menuHandleOop item: anInteger fontID: aFontIDInteger  
	self primSetMenuItemFontID: menuHandleOop item: anInteger fontID: aFontIDInteger  
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 19:00'!
setMenuItemHierarchicalID: menuHandleOop item: anInteger hierID: aMenuID
	self primSetMenuItemHierarchicalID: menuHandleOop item: anInteger hierID: aMenuID! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 16:00'!
setMenuItemKeyGlyph: menuHandleOop item: anInteger glyph:  inGlyphInteger
	self primSetMenuItemKeyGlyph: menuHandleOop item: anInteger glyph:  inGlyphInteger! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/25/2004 16:55'!
setMenuItemModifiers: menuHandleOop item: anInteger inModifiers: modifers
	| modifiersInteger |
	modifiersInteger := self resolveModifiersInteger: modifers.
	self primSetMenuItemModifiers: menuHandleOop item: anInteger inModifiers:  modifiersInteger 
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 11:15'!
setMenuItemText: menuHandleOop item: anInteger itemString: aMenuItemText
	| str255 |
	
	str255 := self convertToStr255: aMenuItemText.
	self primSetMenuItemText: menuHandleOop item: anInteger itemString: str255
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 8/26/2004 12:50'!
setMenuItemTextEncoding: menuHandleOop item: anInteger inScriptID: aTextEncodingOop
	self primSetMenuItemTextEncoding: menuHandleOop item: anInteger inScriptID: aTextEncodingOop
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menus' stamp: 'JMM 10/1/2004 13:17'!
setMenuTitle: menuHandleOop  title: aMenuText
	| str255 |
	
	str255 := self convertToStr255: aMenuText.
	self primSetMenuTitle: menuHandleOop  title: str255
	
! !

!HostSystemMenusMacOS9 methodsFor: 'accessing-menuBar' stamp: 'JMM 10/15/2004 12:42'!
showMenuBar: aWindowIndex
	self primShowMenuBar! !

HostSystemMenusMacOS9 subclass: #HostSystemMenusMacOSX
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusMacOSX commentStamp: 'JMM 10/22/2004 10:14' prior: 0!
Implementation for os-x specific menu logic

Their is a lot to do, first we must disable the hide command key, enable the Quit Squeak VM in the application menu, add items to the File menu, enable the edit menu, and install and alter the Window menu. This requires access to a few specific os-x menu calls to get menus by commandID. Both the application menu and the Window menu are found by commandID information, menu items on these special menus are also found by commandID since the menus hide menu items by default. !

!HostSystemMenusMacOSX class methodsFor: 'instance creation' stamp: 'John M McIntosh 10/31/2008 16:46'!
isActiveHostMenuProxyClass
"Am I active?"
	^false.
	"      ...........^Smalltalk platformName  = 'Mac OS' and: [Smalltalk osVersion asInteger >= 1000]"! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'md 7/28/2009 18:51'!
addMenus
	
	| menu items |
	
	menu := self newMenu: 4 menuTitle: 'Tools'.
	items := self buildSubMenusFor: World worldMenu openMenu.
	items removeLast.
	items add: (HostSystemMenusMenuItem subMenu: 200 menuString: 'More...').
	self appendMenu: menu menuItems: items.
	self insertMenu: menu beforeID: 0.
	
	items := self buildSubMenusFor: World worldMenu  registeredToolsMenu.
	menu := self newMenu: 200 menuTitle: 'registeredToolsMenu'.
	self insertMenu: menu beforeID: -1.
	self appendMenu: menu menuItems: items.
	
	menu := self newMenu: 5 menuTitle: 'Windows'.
	items := self buildSubMenusFor: World worldMenu  windowsMenu.
	self appendMenu: menu menuItems: items.
	self insertMenu: menu beforeID: 0.
	
	
	menu := self newMenu: 6 menuTitle: 'Debug'.
	items := self buildSubMenusFor: World worldMenu  debugMenu.
	self appendMenu: menu menuItems: items.
	self insertMenu: menu beforeID: 0.	
		
		
	menu := self newMenu: 7 menuTitle: 'System'.
	items := self buildSubMenusFor: World worldMenu  systemMenu.
	items at: 3 put: (HostSystemMenusMenuItem subMenu: 201 menuString: 'Preferences...').
	self appendMenu: menu menuItems: items.
	self insertMenu: menu beforeID: 0.
	

	items := self buildSubMenusFor: World worldMenu  appearanceMenu.
	items at: 2 put: (HostSystemMenusMenuItem subMenu: 202 menuString: 'System fonts...').
	menu := self newMenu: 201 menuTitle: 'appearanceDo'.
	self insertMenu: menu beforeID: -1.
	self appendMenu: menu menuItems: items.
	
	items := self buildSubMenusFor: Preferences fontConfigurationMenu.
	menu := self newMenu: 202 menuTitle: 'SystemFonts'.
	self insertMenu: menu beforeID: -1.
	self appendMenu: menu menuItems: items.

	! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'md 7/28/2009 18:03'!
alterFileMenu 
	| fileMenu items toolSetMenuItems |	
	fileMenu := self getMenuHandle: 2.
	items := OrderedCollection 
			with: (HostSystemMenusMenuItem menuString: 'Quit do not save')
			with: (HostSystemMenusMenuItem menuString: '-').
	toolSetMenuItems := ToolSet default mainMenuItems.
	toolSetMenuItems do: [:e | 
			items add: (HostSystemMenusMenuItem menuString: (e at: 1) 
				handler: [:evt | StandardToolSet perform: (e at: 2)])].
	items add: (HostSystemMenusMenuItem menuString: '-');
		add: (HostSystemMenusMenuItem menuString: 'Save' 
				handler: [:evt | SmalltalkImage current snapshot: true andQuit: false ]);
		add: (HostSystemMenusMenuItem menuString: 'Save As...' 
				handler: [:evt | SmalltalkImage current saveAs]);
		add: (HostSystemMenusMenuItem menuString: 'Save As New Version' 
				handler: [:evt | SmalltalkImage current saveAsNewVersion]).
	(self countMenuItems: fileMenu) > 1 
		ifTrue: 
			[1 to: items size do: 
				[:i | self setHandlerForMenu: 2 item: i  handler: (items at: i)]]
		ifFalse:
			[self deleteMenuItem: fileMenu item: 1.
			self appendMenu: fileMenu menuItems: items].! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 1/15/2007 13:25'!
appendStandardWindowMenu: inOptions
	| commandID menuItemIndex windowMenu xID x |
	
	"See http://developer.apple.com/documentation/Carbon/Reference/Carbon:=Event:=Manager:=Ref/CarbonEventsRef/enum:=group:=5.html"
	"Install standard window menu, 
	Disable minimize window menu key,
	Disable hide application cmd key
	Note that after 10.2.x to alter the standard window menu you must do a getIndMenuItemWithCommandID:item: to have the menu built. Also it appears we must do a getMenuID/getMenuHandle to grab the correct handle, versus the template"

	"Build the standard Window menu and disable minimize cmd key"
	windowMenu := self createStandardWindowMenu: inOptions. 
	self insertMenu: windowMenu beforeID: 0.
	xID := self getMenuID: windowMenu.
	x := self getMenuHandle: xID. 

	commandID := MacOSType buildOSTypeFromCharString: 'mini'.
	menuItemIndex := self getIndMenuItemWithCommandID: x item: commandID.
	self setItemCmd: x item: 1 cmdChar: 0.
! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'stephane.ducasse 4/13/2009 21:08'!
buildSubMenusFor: menu
	| items |
	
	items := OrderedCollection new. 
	menu items do: [:e |
		items add: (HostSystemMenusMenuItem menuString: (self modifySqueakMenu: e contents) 
				handler: [:evt | 
					e doButtonAction])].	
	^items	
! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 10/6/2004 16:48'!
createStandardWindowMenu: inOptions
	^self primCreateStandardWindowMenu: inOptions! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 1/15/2007 13:25'!
disableApplicationHide: aMenuRef 
		"Disable the hide cmd key"
	| commandID menuItemIndex |

	commandID := MacOSType buildOSTypeFromCharString: 'hide'.
	menuItemIndex := self getIndMenuItemWithCommandID: aMenuRef item: commandID.
	self setItemCmd: aMenuRef item: menuItemIndex cmdChar: 0.
! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 5/15/2006 20:02'!
disableHideMenuCmd
	| commandID menuRef menuItemIndex |

	"Comand ID for hide"

	commandID := MacOSType buildOSTypeFromCharString: 'hide'.
	menuRef := self getIndMenuWithCommandID: 0 item: commandID.
	menuItemIndex := self getIndMenuItemWithCommandID: 0 item: commandID.
	self setItemCmd: menuRef item: menuItemIndex cmdChar: 0.

! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 10/7/2004 10:36'!
disableMenuCommand: menuHandleOop command: aCommandID
	self primDisableMenuCommand: menuHandleOop command: aCommandID! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 1/15/2007 13:25'!
enableApplicationQuit: aMenuRef 
	| commandID |

	commandID := MacOSType buildOSTypeFromCharString: 'quit'.
	self enableMenuCommand: aMenuRef command: commandID.
	
	! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 10/7/2004 10:37'!
enableMenuCommand: menuHandleOop command: aCommandID
	self primEnableMenuCommand: menuHandleOop command: aCommandID! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 1/15/2007 13:24'!
findApplicationMenuViaHideMenuItem
	| commandID menuRef |

	commandID := MacOSType buildOSTypeFromCharString: 'hide'.
	menuRef := self getIndMenuWithCommandID: 0 item: commandID.
	^menuRef
! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 10/8/2004 12:16'!
getIndMenuItemWithCommandID: aMenuHandle item: aCommandID
	^self primGetIndMenuItemWithCommandID: aMenuHandle commandID: aCommandID! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'JMM 10/8/2004 12:16'!
getIndMenuWithCommandID: aMenuHandle item: aCommandID
	^self primGetIndMenuWithCommandID: aMenuHandle commandID: aCommandID! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'marcus.denker 11/21/2008 12:20'!
modifySqueakMenu: aString
	| results fixIndex middleCharacter |
	results := aString.
	results replaceAll: $; with: Character space.
	results replaceAll: $^ with: Character space.
	results replaceAll: $!! with: Character space.
	results replaceAll: $< with: Character space.
	results replaceAll: $/ with: Character space.
	fixIndex := results indexOf: $(.
	[fixIndex > 0]
		whileTrue: [
			[(results at: fixIndex + 2) = $)
				ifTrue: [middleCharacter := results at: fixIndex + 1.
						(middleCharacter = Character space or: [middleCharacter = $(])
							ifTrue: [results at: fixIndex put: Character space]
							ifFalse: [results at: fixIndex put: $/.].
						results at: fixIndex + 1 put: middleCharacter asUppercase.
						results at: fixIndex + 2 put: Character space]
				ifFalse: [results at: fixIndex put: Character space]]
					ifError: [results at: fixIndex put:  Character space].
			fixIndex := results indexOf: $(].
	^ results! !

!HostSystemMenusMacOSX methodsFor: 'system primitives' stamp: 'JMM 10/6/2004 16:51'!
primCreateStandardWindowMenu: inOptions 
	<primitive: 'primitiveCreateStandardWindowMenu' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOSX methodsFor: 'system primitives' stamp: 'JMM 10/7/2004 10:37'!
primDisableMenuCommand: menuHandleOop command: aCommandID
	<primitive: 'primitiveDisableMenuCommand' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOSX methodsFor: 'system primitives' stamp: 'JMM 10/7/2004 10:37'!
primEnableMenuCommand: menuHandleOop command: aCommandID
	<primitive: 'primitiveEnableMenuCommand' module: 'MacMenubarPlugin'>
	self primitiveFailed! !

!HostSystemMenusMacOSX methodsFor: 'system primitives' stamp: 'JMM 10/8/2004 12:16'!
primGetIndMenuItemWithCommandID: aMenuHandle commandID: aCommandID
	<primitive: 'primitiveGetIndMenuItemWithCommandID' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOSX methodsFor: 'system primitives' stamp: 'JMM 10/8/2004 12:17'!
primGetMenuItemCommandID: aMenuHandle item: anInteger
	<primitive: 'primitiveGetMenuItemCommandID' module: 'MacMenubarPlugin'>
	self primitiveFailed
	! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'adrian_lienhard 7/18/2009 15:57'!
rebuildApplicationMenuHandlers: aMenuRef
	| maximumItems applicationMenuItemsTitles applicationMenuItems m applicationQuit |

	maximumItems := self countMenuItems: aMenuRef.
	applicationMenuItemsTitles := (1 to: maximumItems) collect: [:i | self getMenuItemText: aMenuRef item: i]. 	
	applicationMenuItems := applicationMenuItemsTitles collect: [:e | HostSystemMenusMenuItem menuString: e].
	applicationQuit := applicationMenuItems detect: [:e | e text = 'Quit VM '] ifNone: [nil].
	applicationQuit ifNotNil: [applicationQuit handler: 
		[:evt | SmalltalkImage current snapshot:
			(self confirm: 'Save changes before quitting?'
				orCancel: [^ self])
				andQuit: true]].
	m := Dictionary new.
	applicationMenuItems doWithIndex:[:e :i | m at: i put: e].
	self menus at: (self getMenuID: aMenuRef) put: m.

! !

!HostSystemMenusMacOSX methodsFor: 'utility' stamp: 'md 7/28/2009 18:52'!
reworkFileMenu 
	| menuRef |

	menuRef := self findApplicationMenuViaHideMenuItem.
	self rebuildApplicationMenuHandlers: menuRef.
	self disableApplicationHide: menuRef.
	self enableApplicationQuit: menuRef.
	self alterFileMenu.
	self addMenus.
	
	! !

HostSystemMenusMacOSX subclass: #HostSystemMenusMacOSXExample
	instanceVariableNames: 'applicationQuitMenuItem editReaderModeMenuItem'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusMacOSXExample classSide methodsFor: 'instance creation' stamp: 'John M McIntosh 10/31/2008 16:46'!
isActiveHostMenuProxyClass
"Am I active?"
	^(SmalltalkImage current platformName  = 'Mac OS' and: [SmalltalkImage current  osVersion asInteger >= 1000])! !

!HostSystemMenusMacOSXExample methodsFor: 'handlers' stamp: 'JMM 12/21/2006 00:11'!
appendStandardWindowMenu: inOptions
	! !

!HostSystemMenusMacOSXExample methodsFor: 'handlers' stamp: 'JMM 1/15/2007 12:05'!
rebuildApplicationMenuHandlers: aMenuRef using: aMenuBarMgr
	| maximumItems applicationMenuItemsTitles applicationMenuItems m |

	maximumItems := aMenuBarMgr countMenuItems: aMenuRef.
	applicationMenuItemsTitles := (1 to: maximumItems) collect: [:i | aMenuBarMgr getMenuItemText: aMenuRef item: i]. 	
	applicationMenuItems := applicationMenuItemsTitles collect: [:e | HostSystemMenusMenuItem menuString: e].
	applicationQuitMenuItem := applicationMenuItems detect: [:e | e text = 'Quit Example'] ifNone: [nil].
	applicationQuitMenuItem ifNotNil: [applicationQuitMenuItem handler: [self halt]].
	m := Dictionary new.
	applicationMenuItems doWithIndex:[:e :i | m at: i put: e].
	aMenuBarMgr menus at: (aMenuBarMgr getMenuID: aMenuRef) put: m.

! !

!HostSystemMenusMacOSXExample methodsFor: 'initialize-release' stamp: 'JMM 12/21/2006 00:48'!
resetMenuBar! !

!HostSystemMenusMacOSXExample methodsFor: 'initialize-release' stamp: 'JMM 12/21/2006 00:14'!
reviseHostMenus

	self reworkApplicationMenu: self.
	self reworkFileMenu: self.
	self reworkEditMenu: self.
! !

!HostSystemMenusMacOSXExample methodsFor: 'handlers' stamp: 'JMM 12/21/2006 00:39'!
reworkApplicationMenu: aMenuBarMgr
	| menuRef commandID menuItemIndex |

	commandID := MacOSType buildOSTypeFromCharString: 'hide'.
	menuRef := aMenuBarMgr getIndMenuWithCommandID: 0 item: commandID.
	menuItemIndex := aMenuBarMgr getIndMenuItemWithCommandID: 0 item: commandID.
	aMenuBarMgr setItemCmd: menuRef item: menuItemIndex cmdChar: $H.
	self rebuildApplicationMenuHandlers: menuRef using: aMenuBarMgr.
	commandID := MacOSType buildOSTypeFromCharString: 'quit'.
	aMenuBarMgr  enableMenuCommand: menuRef command: commandID.
	commandID := MacOSType buildOSTypeFromCharString: 'abou'.
	aMenuBarMgr  enableMenuCommand: menuRef command: commandID.


! !

!HostSystemMenusMacOSXExample methodsFor: 'handlers' stamp: 'JMM 12/21/2006 00:34'!
reworkEditMenu: aMenuBarMgr
	| items editMenuID editMenu n |

	editMenuID := 3.
	editMenu := aMenuBarMgr getMenuHandle: editMenuID.
	items := OrderedCollection new.
		items add: (HostSystemMenusMenuItem menuString: 'Undo' keyboardKey: $z virtualKeyValue: 6);
		add: (HostSystemMenusMenuItem menuString: '-');
		add: (HostSystemMenusMenuItem menuString: 'Cut' keyboardKey: $x virtualKeyValue: 7);
		add: (HostSystemMenusMenuItem menuString: 'Copy' keyboardKey: $c virtualKeyValue: 8);
		add: (HostSystemMenusMenuItem menuString: 'Paste' keyboardKey: $v virtualKeyValue: 9);
		add: (HostSystemMenusMenuItem menuString: 'Clear').
	n := aMenuBarMgr countMenuItems: editMenu.
	n to: 1 by: -1 do: [:i | aMenuBarMgr deleteMenuItem: editMenu item: i].
	aMenuBarMgr appendMenu: editMenu menuItems: items.	
	editMenu := aMenuBarMgr getMenuHandle: editMenuID.
	n := aMenuBarMgr countMenuItems: editMenu.
	1 to: n by: 1 do: [:j | aMenuBarMgr enableMenuItem: editMenu item: j].
! !

!HostSystemMenusMacOSXExample methodsFor: 'handlers' stamp: 'JMM 12/21/2006 00:21'!
reworkFileMenu: aMenuBarMgr
| items fileMenuID fileMenu n |

	fileMenuID := 2.
	fileMenu := aMenuBarMgr getMenuHandle: fileMenuID.
	items := OrderedCollection new.
	items add:  (HostSystemMenusMenuItem menuString: 'Quit do not save').
	n := aMenuBarMgr countMenuItems: fileMenu.
	n to: 1 by: -1 do: [:i | aMenuBarMgr deleteMenuItem: fileMenu item: i].
	aMenuBarMgr appendMenu: fileMenu menuItems: items.	! !

!HostSystemMenusMacOSXExample methodsFor: 'utility' stamp: 'JMM 9/18/2006 15:42'!
setShiftKeyForItems: items  startAtOffset: aStartNumber inMenu: aMenu useMgr: aMenuBarMgr
	| item |
	1 to: items size do: [:i |
		item := items at: i.
		item shift ifTrue:
			[
aMenuBarMgr setMenuItemModifiers: aMenu item: aStartNumber+i-1 inModifiers: #(#shift).]].! !

!HostSystemMenusProxy class methodsFor: 'instance creation' stamp: 'JMM 10/12/2004 11:13'!
isActiveHostMenuProxyClass
	^false.! !

!HostSystemMenusProxy class methodsFor: 'instance creation' stamp: 'JMM 10/12/2004 12:35'!
new
	^self basicNew initialize! !

!HostSystemMenusProxy class methodsFor: 'registery' stamp: 'JMM 10/12/2004 11:17'!
register: anObject
	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry add: anObject! !

!HostSystemMenusProxy class methodsFor: 'registery' stamp: 'JMM 10/12/2004 11:18'!
registry
	WeakArray isFinalizationSupported ifFalse:[^nil].
	^Registry isNil
		ifTrue:[Registry := WeakRegistry new]
		ifFalse:[Registry].! !

!HostSystemMenusProxy class methodsFor: 'registery' stamp: 'JMM 10/12/2004 11:18'!
unregister: anObject
	WeakArray isFinalizationSupported ifFalse:[^anObject].
	self registry remove: anObject ifAbsent:[]! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
appendMenu: aMenuHandle menuItems: aCollection! !

!HostSystemMenusProxy methodsFor: 'accessing' stamp: 'JMM 5/15/2006 21:42'!
application
	^application! !

!HostSystemMenusProxy methodsFor: 'accessing' stamp: 'JMM 5/15/2006 21:42'!
application: aValue
	application := aValue! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
checkMenuItem: aMenuHandle item: anInteger checked: aBoolean! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:09'!
clearMenuBar! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
countMenuItems: aMenuHandle! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:09'!
createMenuBar! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 14:32'!
defaultMenuBarForWindowIndex: aWindowIndex
	^self! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
deleteMenu: aMenuHandle! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
deleteMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'initialize-release' stamp: 'JMM 10/12/2004 14:13'!
destroyEveryThing
	self unregister! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
disableMenuItem: aMenuHandle item: aNumb! !

!HostSystemMenusProxy methodsFor: 'initialize-release' stamp: 'JMM 10/12/2004 12:21'!
disposeMenuBar! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:11'!
drawMenuBar! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
enableMenuItem: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'finalization' stamp: 'JMM 10/12/2004 11:20'!
finalize
	[self destroyEveryThing] ifError: [:err :rcvr |].
	! !

!HostSystemMenusProxy methodsFor: 'accessing' stamp: 'JMM 10/12/2004 12:45'!
getHandlerForMenu: aMenuID item: anItem
	^[:nothing | ]! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:16'!
getItemCmd: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getItemIcon: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getItemMark: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getItemStyle: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getMenuHandle: aMenuID! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getMenuID: aMenuHandle! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getMenuItemText: aMenuHandle item: aNumber! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
getMenuTitle: aMenuHandle! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:11'!
hideMenuBar! !

!HostSystemMenusProxy methodsFor: 'initialize-release' stamp: 'alain.plantec 5/28/2009 09:57'!
initialize
	super initialize.
	self register! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:17'!
insertMenu: aMenuHandle beforeID: anId! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
insertMenuItem: menuHandleOop item: anItem afterItem: anInteger
! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:12'!
isMenuBarVisible
	^true! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
isMenuItemEnabled: aMenuHandle item: aNumber
! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
newMenu: xmenuID menuTitle: menuTitle! !

!HostSystemMenusProxy methodsFor: 'finalization' stamp: 'JMM 10/12/2004 11:19'!
register
	^self class register: self! !

!HostSystemMenusProxy methodsFor: 'initialize-release' stamp: 'JMM 5/15/2006 23:24'!
reviseHostMenus! !

!HostSystemMenusProxy methodsFor: 'accessing' stamp: 'JMM 10/12/2004 12:14'!
setHandlerForMenu: aMenuID item: anItem handler: aHandler
! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
setItemCmd: menuHandleOop item: anInteger cmdChar: anIntegerCmdChar! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
setItemMark: menuHandleOop item: anInteger markChar: aMarkChar! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
setItemStyle: menuHandleOop item: anInteger style: aStyle! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:18'!
setMenuItemHierarchicalID: menuHandleOop item: anInteger hierID: aMenuID! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:19'!
setMenuItemModifiers: menuHandleOop item: anInteger inModifiers: aUInt8! !

!HostSystemMenusProxy methodsFor: 'accessing-menus' stamp: 'JMM 10/12/2004 12:19'!
setMenuTitle: menuHandleOop  title: aMenuText! !

!HostSystemMenusProxy methodsFor: 'accessing-menuBar' stamp: 'JMM 10/12/2004 12:12'!
showMenuBar! !

!HostSystemMenusProxy methodsFor: 'finalization' stamp: 'JMM 10/12/2004 11:20'!
unregister
	^self class unregister: self! !

HostSystemMenusProxy subclass: #HostSystemMenusWindows
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!HostSystemMenusWindows class methodsFor: 'instance creation' stamp: 'JMM 1/15/2007 12:00'!
isActiveHostMenuProxyClass
"Am I active?"
	^SmalltalkImage current  platformName  =  'Win32'! !

!HostSystemMenusWindows methodsFor: 'as yet unclassified' stamp: 'be 8/13/2006 15:54'!
toggleReaderMode: aValue! !

HostSystemMenusProxy subclass: #MacOSType
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HostMenus-Mac'!

!MacOSType class methodsFor: 'utility' stamp: 'JMM 1/15/2007 12:28'!
buildOSTypeFromCharString: folderTypeData 
	"preserve platform endianness"

	^folderTypeData asByteArray unsignedLongAt: 1 bigEndian: true! !
HostSystemMenus initialize!
